/* Grind: cryptogram generator. Copyright (c) 1990 by Richard F. Parker
   as a promotion for Thunderhead Software, Inc.  All rights reserved.
   You may copy, modify and use this software freely, as long as
   proper credit is given to the author, Rich Parker.  You may dis-
   tribute this software only in unmodified form, with the original
   readme documentation and the Thunderhead Software Catalog.

   This software was written in fairly standard ansi-C, and compiled
   with MIX software's POWER C compiler.  I am not required to mention
   their name, but they are a great compiler company, and deserve the
   credit.  Think of it: a fast C compiler, with debugger and library
   source for under $100 with a half-decent assembler and debugger.
*/

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <direct.h>

char sc[28], sc2[28];
int mixflag, premix, mixcount;

main( argc, argv )
int argc;
char *argv[];
{
    int trial, fncnts;
    FILE *inn1, *outt1, *outt2;
    char bull[100], bull2[100], bull3[100], c;
    char fndr[MAXDRIVE], fndi[MAXDIR], fnfi[MAXFILE], fnex[MAXEXT];

    printf( "Grind: crypto-generator.  Copyright 1990 by Richard F. Parker\n");
    printf( "This software is a FREEWARE promotion for Thunderhead Software, Inc.\n");
    printf( "See our enclosed catalog for details, or contact us at:\n" );
    printf( "           Thunderhead Software\n");
    printf( "           P.O. Box 91\n");
    printf( "           McKeesport, Pa. 15135\n");
    printf( "           412-751-4020\n\n");

    mixcount = 0;

    if( argc < 2 ) {
        printf( "Format: GRIND <infile>\n");
        exit(0);
    }

    bull[0] = 0;
    fncnts = fnsplit( argv[1], fndr, fndi, fnfi, fnex );

    fnmerge( bull, fndr, fndi, fnfi, fnex );
    fnmerge( bull2, fndr, fndi, fnfi, ".out" );

    if( (inn1 = fopen( bull, "rb" ) ) == NULL ) {
        printf( "Sorry, but I cannot open %s\n", bull );
        printf( "Argv = %s\n", argv[1] );
        exit(1);
    }

    if( (outt1 = fopen( "t.t", "ab" ) ) == NULL ) {
        printf( "Sorry...temp file opening error.  Cannot open 't.t'\n");
        fclose( inn1 );
        exit(1);
    }

    if( (outt2 = fopen( bull2, "ab" ) ) == NULL ) {
        printf( "Sorry, but I cannot open %s\n", bull2 );
        fclose( inn1 ); fclose( outt1 );
        exit(1);
    }

    fgets( bull3, 30, inn1 ); trial =  atoi( bull3 );
    srand( trial ); mix();

    printf( "Starting\n");

    while( !(feof( inn1 )) ) {

        c = fgetc( inn1 );
        fputc( c, outt1 );

        if( c > 64 && c < 92 ) {
            premix = 0;
            fputc( sc[c-65], outt2 );
        }
        else fputc( c, outt2 );

        if( c == 10 ) {
            if( premix > 1 ) mix();
            else premix++;
        }
    }

    fclose( inn1 ); fclose( outt1 ); outt1 = fopen( "t.t", "rb" );

    while( !feof( outt1 ) ) fputc( fgetc(outt1), outt2 );

    fclose( outt1 ); fclose( outt2 );

    unlink( "t.t" );

    printf( "Sequence Finished.\n" );
}


mix()
{
    register int i, j;

    ++mixcount;
    printf( "Mixing: round %d\n", mixcount );

    for( i = 0; i < 27; i++ ) {
        sc[i] = 0;
        sc2[i] = i + 65;
    }
    sc2[26] = 0;

    for( i = 25; i > -1; i-- ) {
        j = ran(i);
        sc[i] = sc2[j];
        sc2[i+1] = 0;
        while( sc2[j] > 0 && j < i ) {
            sc2[j] = sc2[j+1];
            j++;
        }
    }
    sc[26] = sc[0];

    for( i = 0; i < 26; i++ ) {
        if( sc[i] == i + 65 ) {
            j = sc[i];
            sc[i] = sc[i+1];
            sc[i+1]=j;
        }
    }

    mixflag = premix = 0;
}

ran( how )
int how;
{
    float f;

    if( how < 2 ) return( 0 );
    f = (float)rand() / 32767.0; f *= (float)how;
    return( (int)f );
}


